import logging

from lib.Axes1Ref import *
from lib.GUI import *
from lib.VGR import *


lev = None


def initlib_log(lev):
    #TRACE0_A1R, TRACE_A1R, DEBUG_A1R
    initlog_A1R(1, 2, 3)
    #TRACE0_GUI, TRACE_GUI, DEBUG_GUI
    initlog_GUI(5, 15, 25)
    #TRACE0_VGR, TRACE_VGR, DEBUG_VGR
    initlog_VGR(6, 16, 26)
    # Logging levels already reserved:
    #  CRITICAL 50
    #  ERROR 40
    #  WARNING 30
    #  INFO 20
    #  DEBUG 10 (Debug all)
    #  #TRACE 9 (no loops)
    #  #TRACE0 1 (with loops)
    #  NOTSET 0

    logging.TRACE0 = 1
    logging.addLevelName(logging.TRACE0 , 'TRACE0')
    logging.TRACE = 9
    logging.addLevelName(logging.TRACE , 'TRACE')

    logging.basicConfig(\
    #filename='/opt/ft/workspaces/FactoryMain.log',\
    #filemode='w',\
    level=lev,\
    format="%(asctime)s [%(threadName)s] %(levelname)-10s %(funcName)3s %(message)s   #%(filename)3s:%(lineno)d"\
    )


