import logging
import math
import time

from lib.Axes1Ref import *
from lib.controller import *
from lib.display import *
from lib.VGR import *
from lib.VGR_Axes1Ref import *


_tr0 = None
_tr = None
_dg = None
b = None
num = None
offset_y = None
poslist = None
i_pos = None


def initlog_VGR(_tr0, _tr, _dg):
    global b, num, offset_y, poslist, i_pos
    logging.TRACE0_VGR= _tr0
    logging.addLevelName(logging.TRACE0_VGR , 'TRACE0_VGR')
    logging.TRACE_VGR = _tr
    logging.addLevelName(logging.TRACE_VGR , 'TRACE_VGR')
    logging.DEBUG_VGR = _dg
    logging.addLevelName(logging.DEBUG_VGR, 'DEBUG_VGR')


def thread_VGR():
    global _tr0, _tr, _dg, b, num, offset_y, poslist, i_pos
    logging.log(logging.TRACE_VGR, '-')
    offset_y = 200
    poslist = [[20, 700, 50], [310, 700, 500], [600, 700, 300]]
    init_VGR()
    moveRef_VGR_P123()
    while True:
        if display.get_attr("txt_switch_cycle.checked"):
            enable_buttons(False)
            for i_pos in poslist:
                moveAbs_VGR_P123_list(i_pos)
                moveRel_VGR_S123(0, offset_y, 0)
                grip()
                time.sleep(0.8)
                moveRel_VGR_S123(0, -offset_y, 0)
                time.sleep(1)
            moveAbs_VGR_P123_list(get_pos(1))
            moveRel_VGR_S123(0, offset_y, 0)
            release()
            moveRel_VGR_S123(0, -offset_y, 0)
            time.sleep(1)
            moveRef_VGR_P123()
            enable_buttons(True)
            display.set_attr("txt_switch_cycle.checked", str(False).lower())
        time.sleep(0.01)


def thread_GUI():
    global _tr0, _tr, _dg, b, num, offset_y, poslist, i_pos
    while True:
        display.set_attr("txt_label_message.text", str('<h3>pos [x,y,z]: {}</h3>'.format(get_abspos())))
        time.sleep(0.4)


def enable_buttons(b):
    global _tr0, _tr, _dg, num, offset_y, poslist, i_pos
    display.set_attr("txt_button_test.enabled", str(b).lower())
    display.set_attr("txt_button_grip.enabled", str(b).lower())
    display.set_attr("txt_button_release.enabled", str(b).lower())
    display.set_attr("txt_button_pos1.enabled", str(b).lower())
    display.set_attr("txt_button_pos2.enabled", str(b).lower())
    display.set_attr("txt_button_pos3.enabled", str(b).lower())


def get_offset_y():
    global _tr0, _tr, _dg, b, num, offset_y, poslist, i_pos
    return offset_y


def get_pos(num):
    global _tr0, _tr, _dg, b, offset_y, poslist, i_pos
    return poslist[int(num - 1)]


def grip():
    global _tr0, _tr, _dg, b, num, offset_y, poslist, i_pos
    logging.log(logging.TRACE_VGR, '-')
    TXT_VGR_M_O7_compressor.on()
    time.sleep(0.2)
    TXT_VGR_M_O8_magnetic_valve.on()
    time.sleep(0.3)


def release():
    global _tr0, _tr, _dg, b, num, offset_y, poslist, i_pos
    logging.log(logging.TRACE_VGR, '-')
    TXT_VGR_M_O8_magnetic_valve.off()
    TXT_VGR_M_O7_compressor.off()
    time.sleep(1)


