import fischertechnik.factories as txt_factory

txt_factory.init()
txt_factory.init_input_factory()
txt_factory.init_output_factory()
txt_factory.init_motor_factory()
txt_factory.init_counter_factory()

TXT_VGR_M = txt_factory.controller_factory.create_graphical_controller()
TXT_VGR_M_I1_mini_switch = txt_factory.input_factory.create_mini_switch(TXT_VGR_M, 1)
TXT_VGR_M_I2_mini_switch = txt_factory.input_factory.create_mini_switch(TXT_VGR_M, 2)
TXT_VGR_M_I3_mini_switch = txt_factory.input_factory.create_mini_switch(TXT_VGR_M, 3)
TXT_VGR_M_O7_compressor = txt_factory.output_factory.create_compressor(TXT_VGR_M, 7)
TXT_VGR_M_O8_magnetic_valve = txt_factory.output_factory.create_magnetic_valve(TXT_VGR_M, 8)
TXT_VGR_M_M1_encodermotor = txt_factory.motor_factory.create_encodermotor(TXT_VGR_M, 1)
TXT_VGR_M_M2_encodermotor = txt_factory.motor_factory.create_encodermotor(TXT_VGR_M, 2)
TXT_VGR_M_M3_encodermotor = txt_factory.motor_factory.create_encodermotor(TXT_VGR_M, 3)
TXT_VGR_M_C1_motor_step_counter = txt_factory.counter_factory.create_encodermotor_counter(TXT_VGR_M, 1)
TXT_VGR_M_C1_motor_step_counter.set_motor(TXT_VGR_M_M1_encodermotor)
TXT_VGR_M_C2_motor_step_counter = txt_factory.counter_factory.create_encodermotor_counter(TXT_VGR_M, 2)
TXT_VGR_M_C2_motor_step_counter.set_motor(TXT_VGR_M_M2_encodermotor)
TXT_VGR_M_C3_motor_step_counter = txt_factory.counter_factory.create_encodermotor_counter(TXT_VGR_M, 3)
TXT_VGR_M_C3_motor_step_counter.set_motor(TXT_VGR_M_M3_encodermotor)

txt_factory.initialized()