import logging
import math
import time

from lib.display import *
from lib.Test import *
from lib.VGR import *
from lib.VGR_Axes1Ref import *


_tr0 = None
_tr = None
_dg = None


def initlog_GUI(_tr0, _tr, _dg):
    logging.TRACE0_GUI = _tr0
    logging.addLevelName(logging.TRACE0_GUI , 'TRACE0_GUI')
    logging.TRACE_GUI = _tr
    logging.addLevelName(logging.TRACE_GUI , 'TRACE_GUI')
    logging.DEBUG_GUI = _dg
    logging.addLevelName(logging.DEBUG_GUI, 'DEBUG_GUI')


def on_txt_button_grip_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    moveRel_VGR_S123(0, get_offset_y(), 0)
    grip()
    time.sleep(1)
    moveRel_VGR_S123(0, -(get_offset_y()), 0)


def on_txt_button_release_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    moveRel_VGR_S123(0, get_offset_y(), 0)
    release()
    time.sleep(1)
    moveRel_VGR_S123(0, -(get_offset_y()), 0)


def on_txt_button_pos1_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    moveAbs_VGR_P123_list(get_pos(1))


def on_txt_button_pos2_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    moveAbs_VGR_P123_list(get_pos(2))


def on_txt_button_pos3_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    moveAbs_VGR_P123_list(get_pos(3))


def on_txt_button_test_clicked(event):
    global _tr0, _tr, _dg
    logging.log(logging.TRACE_GUI, '-')
    test_move_Axes1Ref()
    logging.debug('exit')
    os._exit(os.EX_OK)


display.button_clicked("txt_button_grip", on_txt_button_grip_clicked)
display.button_clicked("txt_button_release", on_txt_button_release_clicked)
display.button_clicked("txt_button_pos1", on_txt_button_pos1_clicked)
display.button_clicked("txt_button_pos2", on_txt_button_pos2_clicked)
display.button_clicked("txt_button_pos3", on_txt_button_pos3_clicked)
display.button_clicked("txt_button_test", on_txt_button_test_clicked)


